#!/usr/local/bin/perl
#	Copyright(C)2001 Ktat, All rights reserved.

use 5.004;
use strict;
use CGI;
use Diary;
# use CGI::Carp qw(fatalsToBrowser);	# for Debug

my $version = 'ver. 1.09';

# Initial Setting
my $cgi_title= "Simple Diary";		# ^Cg
my $comment	 = "Subtitle";			# Tu^Cg
my $css		 = 'diary.css';			# CSSt@C
my @weather  = ('','܂','J');# VC
my $dir 	 = "./data";			# CGI猩Af[^fBNg̏ꏊ(Ō'/'*s*v)B
my $cgi_dir  = "../";				# f[^fBNg猩ACGȈꏊ(Ō'/'*K*v)B
my $method   = "get";				# \؂ւ̃\bh
my $method2  = "get";				# ̃\bh(post)
my $time_d	 = 9;					# GMTƂ̎
my $back_word= "߂";				# ߂郊Ňt(摜Ȃ<img>)
my $back_link= "";					# ߂ꏊ
my $cal_list = 1;					# J_[̃XgȂ1
my $make_html= 0;					# HTMLt@CȂ1
my $cgi_name = "diary.cgi";			# CGI Script̖O

# You needn't change code under here.

my $cgi  = new CGI;
my %cookie = $cgi->cookie("Diary");
my $cookie;
my $year;
my $month;
my $today;
my %RS;
my @er_message;

{
	my($year,$month);
	($today,$month,$year) = (gmtime time + $time_d * 3600)[3,4,5];
	$year +=1900;
	$today = $year.sprintf("%02d",++$month,).sprintf("%02d",$today);
}

foreach my $key ($cgi->param){
	my @value = $cgi->param($key);
	$RS{$key} = $value[0];
	$year  = $value[0]	if $key eq "year";
	$month = $value[0]	if $key eq "month";
}

if(exists $RS{MonthDelete}){
	my $sch = new Diary ($dir,$RS{year},$RS{month},1);
	push(@er_message,"t@C폜sB")		if $sch->month_cancel(\%RS) != 1;
}elsif(exists $RS{Date}){
	my($y,$m) = (substr($RS{Date},0,4),substr($RS{Date},-4,2));
	if(exists $RS{Delete}){# Delete Diary.
		($year,$month) = ($y,$m);
		my $sch = new Diary ($dir,$year,$month,1);
		$sch->cancel(\%RS);
		$sch->rec_db;
		push(@er_message,$sch->{'message'})	if $sch->{'message'};
		$RS{Write} = delete($RS{Delete});
		if($make_html ==1 and !@er_message and substr($RS{Date},0,6) >= substr($today,0,6)){
			open OUT,">$dir/diary.html" or push(@er_message,"t@CJ܂B");
			if(!@er_message){
				select(OUT);
				make_html();
				close OUT;
				select(STDOUT);
			}
		}
		delete($RS{Write});
	}elsif(exists $RS{Write} and exists $RS{content}){# Record Diary.
		($year,$month) = ($y,$m);
		my $sch = new Diary ($dir,$year,$month,1);
		if($sch->reserve(\%RS)){
			$sch->rec_db;
			%cookie = %RS;
		}
		$cookie{content} = "";
		$cookie{subject} = "";
		push(@er_message,$sch->{'message'})	if $sch->{'message'};
		if($make_html ==1 and !@er_message and substr($RS{Date},0,6) >= substr($today,0,6)){
			open OUT,">$dir/diary.html" or push(@er_message,"t@CJ܂B");
			if(!@er_message){
				select(OUT);
				make_html();
				close OUT;
				select(STDOUT);
			}
		}
		delete($RS{Write});
	}elsif(exists $RS{Load}){
		($year,$month) = ($y,$m);
		my $sch = new Diary ($dir,$year,$month,1);
		($RS{subject},$RS{content},$RS{Weather}) = split(/<>/,$sch->get_reserved($RS{Date}));
		$RS{content} =~s/<br>/\n/ig;
		$cookie{content} = "";
		$cookie{subject} = "";
		$cookie{Weather} = "";
	}
}

$cookie = $cgi->cookie(-name=>'Diary',-value=>\%cookie,-expires=>"+720h");

if($year < 0 or $year eq ""){
	($month,$year) = (gmtime time + $time_d * 3600)[4,5];
	$month++;
	$year+=1900;
}

$month = sprintf("%02d",$month);
$year  = sprintf("%04d",$year);

!-e "$dir/password" ? make_pass() : appear();

sub appear{
	if(exists $RS{form_on}){
		print $cgi->header(-cookie=>$cookie);
		make_html(1)
	}else{
		print $cgi->header();
		make_html();
	}
}

sub make_html{
	my $form = shift;
	my $style;
	my $_dir = "";
	if(exists $RS{Write} and !$form){
		$cookie = "";
		$style  = "../$css";
	}else{
		$style  = "./$css";
	}
	local $, = "\n";
	print $cgi->start_html(-title=>$cgi_title,-style=>{-src=>"$style"});
	print qq(\n<a name="top"> </a>\n);
	my $cal = new Calendar($year,$month);
	my $nday = 0;
	my $sch = new Diary ($dir,$year,$month,1);
	print @er_message;
	print "<CENTER><H1>$cgi_title</H1>\n";
	print "<H2>$comment</H2>\n"	if $comment ne "";
	if($cal_list==1){
		$_dir = $cgi_dir	if $RS{Write};
		my $form_on = '';
		$form_on = "&form_on=1"	if exists $RS{form_on} and !exists $RS{Write};
		my %list;
		if(opendir DIR,$dir){
				my @df = map {substr($_,-6) eq ".diary" ? substr($_,0,6): ()} readdir DIR;
				foreach my $diary (sort{$b<=>$a} @df){
					push(@{$list{substr($diary,0,4)}},substr($diary,-2) );
				}
		   closedir DIR;
		}
		print "<TABLE>\n";
		foreach my $year (sort{$b<=>$a}keys(%list)){
			print "<TR><TH>".$year."</TH><TD>".join(" ",map{ qq(<a href="$_dir$cgi_name?year=$year&month=$_$form_on">).($_+0)."</a>" } @{$list{$year}})."</TD></TR>\n";
		}
		print "</TABLE>\n";
	}
	print '<TABLE><TR><TD width="50%" class=left>';
	print "<TABLE cellpadding=0 cellspacing=0><TR><TD class=box></TD><TD class=bar align=center><span class=cal_month>";
	print $year,' ',${['','January','February','March','April','May','June','July','August','September','October','November','December']}[$month];
	print "</span></TD><TD class=box></TD></tr>\n<TR><TD class=bar></TD><TD class=calendar>";
	print '<TABLE class="calendar" border=0>';
	print '<TR><TD class="rest"></TD>',join("",map{"<TD>$_</TD>\n"}qw(     y)),'</TR>';
	Loop: while($nday < $cal->{days}){
		print '<TR>';
		foreach my $day (0..6){
			if(($nday != 0 or $day == $cal->{fday}) and $nday < $cal->{days}){
				$nday++;
				my $rest;
				$rest = ' class="rest2"'	if ($cal->search($nday))[0] eq "rest2";
				$rest = ' class="rest"'		if $day == 0;
				$rest = ' class="today"'	if !exists $RS{Write} and "$year$month$nday" eq $today;
				print qq(<TD align="right"$rest>$nday</TD>);
			}else{
				print "<TD>&nbsp;</TD>";
			}
		}
		print "</TR>\n";
	}
	print '</TABLE>';
	print "</TD><TD class=bar></TD></TR>\n<TR><TD class=box></TD><TD class=bar></TD><TD class=box></TD></TR></TABLE>";
	print "</TD><TD valign=top align=center class=right>";
	print "<br><h2>";
	print "$year ";
	print ${['','Jan.','Feb.','Mar.','Apr.','May','Jun.','Jul.','Aug.','Sep.','Oct.','Nov.','Dec.']}[$month];
	print "</h2>\n";
	{
		$_dir = $cgi_dir	if $RS{Write};
		my $form_on = '';
		$form_on = "&form_on=1"	if exists $RS{form_on} and !exists $RS{Write};
		my($nyear,$nmonth) = ($year,$month+1);
		my($lyear,$lmonth) = ($year,$month-1);
		if($nmonth > 12){$nmonth = 1; $nyear++}
		if($lmonth < 1 ){$lmonth = 12;$lyear--}
		if($form_on or -e $dir."/".sprintf("%04d",$nyear).sprintf("%02d",$nmonth).".diary"){
			print qq(&lt; <a href="$_dir$cgi_name?year=$nyear&month=$nmonth$form_on">Next</a> /);
		}else{
			print qq(&lt; Next /)
		}
		if(!exists $RS{Write} and $make_html == 1){
			print qq(<a href="$dir/diary.html"></a>);
		}elsif($make_html != 1){
			print qq(<a href="$cgi_name?$form_on"></a>);
		}else{
			print qq(<a href="#"></a>);
		}
		if($form_on or -e $dir."/".sprintf("%04d",$lyear).sprintf("%02d",$lmonth).".diary"){
			print  qq(/ <a href="$_dir$cgi_name?year=$lyear&month=$lmonth$form_on">Last</a> &gt;);
		}else{
			print qq(/ Last &gt;)
		}
	}
	print qq(\n<br><br>\n<a href="$back_link">$back_word</a>);
	print "</TD></TR></TABLE>\n";
	form($cal->{days})	if $form == 1;
	print "<br><br>";
	foreach my $day (reverse(1..$cal->{days})){
		$day = sprintf("%02d",$day);
		my $data = $sch->get_reserved("$year$month$day");
		if($data){
			$data =~s/^.*?\t//;
			my @data = split(/<>/,$data);
			$data[1] =~s#^(.*)<SUM(.*?)>(.*)</SUM>(.*)$#do_sum($1,$2,$3,$4)#ei;
			print 	qq{<A name="$year$month$day"> </A>};
			print	$cgi->table({-class=>'diary',-border=>0,-width=>'60%',-cellspacing=>'0'},
					$cgi->Tr([$cgi->td({-class=>'subject'},$cgi->div({-class=>'subject'},"<span class=box></span> $year/$month/$day - $data[0] - $data[2]"))]),
							$cgi->Tr([$cgi->td({-class=>'content'},$cgi->div({-class=>'content'},$data[1]))])
						);
			print $cgi->div({-class=>'space'},'<br>'),"\n"
		}
	}
	print qq(<a href="#top">to Top</a>);
	print $cgi->div({-class=>"copyright"},"- <a href=\"http://www.pure.ne.jp/~learner/\">Simple Diary $version</a> -");
	if(exists $RS{form_on} and !exists $RS{Write}){
		print $cgi->div({-class=>"admin"},qq(<a href="$_dir$cgi_name?year=$year&month=$month"></a>));
	}else{
		print $cgi->div({-class=>"admin"},qq(<a href="$_dir$cgi_name?form_on=1&year=$year&month=$month"></a>));
	}
	print "<CENTER>",$cgi->end_html;
}

sub do_sum{
	my $top 	= shift;
	my $option	= shift;
	my $arg 	= shift;
	my $bottom 	= shift;
	my $sum 	= 0;
	my $html	= "";
	my $tanni   = "";
	my $align   = ' align="right"';
	my $border  = "0";
	my $title   = "";
	$bottom =~s/^<br>//;
	$title  = "<CAPTION>$1</CAPTION>"	if($option=~s/\[(.*)\]//) 			ne "";
	$border = $1						if($option=~s/B:(\d+?)(?:\s|$)//i) 	ne "";
	$tanni  = $1						if($option=~s/T:(.+?)(?:\s|$)//i)  	ne "";
	$align  = ""						if($option=~s/P:left(?:\s|$)//i)   	ne "";
	$align  = ' align="center"'			if($option=~s/P:center(?:\s|$)//i) 	ne "";
	$html = qq{<TABLE class="price"$align border=$border cellspacing=0 cellpadding=2>$title};
	foreach my $line (split /(?:(;)|(<br>))/,$arg){
		my($object,$price) = (split /:/,$line)[0,1];
		$object =~s/\s+//g;
		$price  =~s/\s+//g;
		($sum += $price and $price.=$tanni)	if $price=~/^\d+$/;
		$html.= qq{<TR><TD class="object">$object</TD><TD class="price">$price</TD></TR>}	if $object ne "" and $price ne "";
	}
	$html .= qq{<TR><TD class="object">v</TD><TD class="price">$sum$tanni</TD></TR></TABLE>};
	$html = $align eq ' align="right"' ? $html.$top.$bottom : $top.$html.$bottom ;
	return($html);
}

sub form{
	my $days = shift;
	my %default = ();
	$default{Weather} = 'I';
	if(exists $RS{Load}){
		$default{over}    = 1;
		$default{subject} = $RS{subject};
		$default{content} = $RS{content};
	}elsif(substr($today,0,6) eq substr($RS{Date},0,6) or "$year$month" eq substr($today,0,6)){
		my $sch = new Diary ($dir,substr($today,0,4),substr($today,-4,2),1);
		($default{subject},$default{content},$default{Weather}) = split(/<>/,$sch->get_reserved($today));
		$default{content} =~s/<br>/\n/gi;
		$default{over}    = 1;
	}else{
		$default{over} = 0;
	}
	print $cgi->startform(-method	=> $method2);
	print "<STRONG>LL^</STRONG><br>\n";
	print $year."/".$month."/".
		$cgi->popup_menu(
			-name   => "Date",
			-values => [ map{ $year.$month.sprintf("%02d",$_) }(1..$days)],
			-labels => { map{ $year.$month.sprintf("%02d",$_) => $_ }(1..$days)},
			-default=>$today
		),"<br><br>薼<br>",
		$cgi->textfield(
			-default => $default{subject},
			-override=> $default{over},
			-name=>"subject",
			-size=> 40
		),"<br>VC",
		$cgi->popup_menu(
			-name   => "Weather",
			-values => ['',@weather],
			-labels => {''=>'I'},
			-default=>"$default{Weather}"
		),"<br>e (",
		$cgi->checkbox(
			-name => 'br',
			-value=> 'on',
			-label=> 's'
		),
		$cgi->checkbox(
			-name => 'link',
			-value=> 'on',
			-label=> 'N'
		),
		$cgi->checkbox(
			-name => 'tag',
			-value=> 'on',
			-label=> '^O'
		),
		")<br>",
		$cgi->textarea(
			-default => $default{content},
			-override=> $default{over},
			-name=>"content",
			-cols=> 60,
			-rows=> 5
		),"<br>pX[h<br>",
		$cgi->password_field(
			-name=>"pass",
			-size=> 10,
			-default => $cookie{pass}
		),"<br><br>",
		$cgi->hidden(-value => "1",-name=>'form_on'),
		$cgi->submit(-value => "",-name=>'Write'),
		$cgi->submit(-value => "Ǎ",-name=>'Load'),
		$cgi->submit(-value => "폜",-name=>'Delete'),
		$cgi->reset(-value => "Zbg"),"<br><br>",
		"C͓ɂ킹āuǍvAuvŏ㏑܂B<br>",
		"폜͓ɂ킹āu폜vB<br>",
		$cgi->end_form();
	print "<br><br>",$cgi->startform(-method	=> $method2),
		"<STRONG>̌̃f[^SĂ폜</STRONG><br>\n",
		$cgi->hidden(-value => "1",-name=>'form_on'),
		$cgi->hidden(-value => $year, -name=>'year'),
		$cgi->hidden(-value => $month, -name=>'month'),
		"<br>pX[h<br>",
		$cgi->password_field(
			-name=>"pass",
			-size=> 10,
			-default => $cookie{pass}
		),"<br><br>",
		$cgi->submit(-value => "o͂łH",-name=>"MonthDelete"),
		$cgi->endform();
}

sub time_convert{
	my $t = shift;
	my @t = (gmtime $t+$time_d * 3600)[5,4,3,2,1];
	$t = ($t[0]+1900).'/'.(++$t[1]).'/'.$t[2].' '.sprintf("%02d",$t[3]).':'.sprintf("%02d",$t[4]);
	return $t;
}

sub make_pass{
	my $make_pass = 0;
	if($RS{pass} ne "" and $RS{pass} eq $RS{pass2}){
		$RS{pass} = Diary::do_crypt($RS{pass});
		if(open OUT,">$dir/password"){
			print OUT $RS{pass};
			close OUT;
			$make_pass = 1;
			if(open LOCK,">$dir/unlock"){
				close LOCK
			}else{
				push(@er_message,"$dir/unlock쐬sBōĉ(p[~bV̖肩)B");
			}
		}else{
			push(@er_message,"Can't make a new file(main::make_pass)");
		}
	}else{
			push(@er_message,'pX[hłB')							if exists $RS{pass} and $RS{pass} eq "";
			push(@er_message,'pX[hPԖڂƂQԖڂňقȂĂ܂B')	if $RS{pass} ne "";
	}

	if(!$make_pass){
	$, = "\n";
	print $cgi->header(-title=>'password setting'),
		$cgi->start_html,
		$cgi->h1('Password Setting'),
		join("",@er_message),
		$cgi->start_form(-method =>$method2),
		$cgi->password_field(-name =>'pass'),"<br>",
		$cgi->password_field(-name =>'pass2'),"<br>",
		$cgi->submit(-value=>'send'),
		$cgi->reset(-value=>'Reset'),
		$cgi->end_form,
		$cgi->end_html;
		$,= " ";
	}else{
		appear();
	}
}
